/**
 * Document: MaxCompiler Training (maxcompiler-training.pdf)
 * Chapter: 1      Exercise: 1      Name: Brightness
 * MaxFile name: Brightness
 * Summary:
 *     Adjusts the brightness of an image by adding a constant
 *     value to every pixel.
 */

#include <math.h>
#include <stdio.h>
#include <stdlib.h>

#include "Maxfiles.h"
#include <MaxSLiCInterface.h>

#include "ppmIO.h"

int main(void)
{
	printf("Loading image.\n");
	int32_t *inImage;
	int width = 0, height = 0;
	loadImage("lena.ppm", &inImage, &width, &height, 1);

	int dataSize = width * height * sizeof(int);
	// Allocate a buffer for the output image
	int32_t *outImage = malloc(dataSize);

	printf("Running Kernel.\n");
	Brightness(width * height, inImage, outImage);

	printf("Saving image.\n");
	writeImage("lena_brightness.ppm", outImage, width, height, 1);

	printf("Exiting\n");
	return 0;
}
